#ifndef map_viewer_h
#define map_viewer_h


#include <SFML/Graphics.hpp>
#include <SFML/System.hpp>
#include <thread>
#include <iostream>
#include "../include/map_buffer.h"
#include <chrono>

using namespace sf;
using namespace std;

class Map_Viewer{

public:

	Map_Viewer(): m_thread(&Map_Viewer::show_map,this){
	}

	void launcher(){
		 m_thread.detach();
	}

	void show_map(){
		window = new RenderWindow(VideoMode(MAP_SIZE, MAP_SIZE), "Map!");
		//draw_robot(22,14);
		draw_map_from_file(window);
    	while (window -> isOpen()){
        sf::Event event;
        	while (window -> pollEvent(event))
        	{
            	if (event.type == sf::Event::Closed)
                	window -> close();
        	}
        //draw_map();
        window -> display();
		}
	}

private:

	void draw_map(){
		Map_Buffer_Reader reader;
		Mem_Overhead infos = reader.dequeue();
		if(infos.get_state() == HAS_VALUE){
			switch((infos.get_infos()).get_command()){
				case CONNECT_POINTS:
						draw_line((infos.get_infos()).get_p1(), (infos.get_infos()).get_p2());
					break;
				case DRAW_POINTS:
						draw_point((infos.get_infos()).get_p1());
						draw_point((infos.get_infos()).get_p2());
					break;
			}
		}
	}


	void draw_map_from_file(RenderWindow* window){
		Map_Buffer_FileReader reader;
		int counter = 0;
		// if the first point is 0/0 an error accured, leave while loop
		while(true){
			counter++;
			Infos_Time info = reader.dequeue();
			cout << "waiting Time "  << info.get_time() << endl;
			if(info.get_time() == -1 || counter == 200){
				break;
			}
			int time = info.get_time();
			//this_thread::sleep_for(chrono::milliseconds(time));
			Mem_Infos real_infos =  info.get_infos();
			cout << "command " << real_infos.get_command() << " point "  << real_infos.get_p1().get_x() << " " << real_infos.get_p1().get_y()<< endl;
			switch(real_infos.get_command()){
				case CONNECT_POINTS:
						draw_line(real_infos.get_p1(), real_infos.get_p2());
					break;
				case DRAW_POINTS:
						draw_point(real_infos.get_p1());
						draw_point(real_infos.get_p2());
					break;
			}
			window -> display();
		}
	}

	void draw_point(Position p){
		if(p.get_x() == 0 && p.get_y() == 0){
			return;
		}
		Vertex line[] =
			{
    			Vertex(Vector2f(p.get_x(), p.get_y())),
    			Vertex(Vector2f(p.get_x()+1, p.get_y()+1))
			};
		window -> draw(line, 2, Lines);	
	}

	void draw_line(Position p1, Position p2){
		Vertex line[] =
			{
    			Vertex(Vector2f(p1.get_x(), p1.get_y())),
    			Vertex(Vector2f(p2.get_x(), p2.get_y()))
			};
		window -> draw(line, 2, Lines);	
	}

	void draw_robot(int width, int length){
		RectangleShape rectangle(Vector2f(200-width/2, 200-length));
		rectangle.setSize(sf::Vector2f(width, length));
		rectangle.move(200-width/2, 200-length/2);
		window -> draw(rectangle);
		window -> draw(rectangle);

		// draw coordinate axes
		sf::Vertex liney[] =
		{
    		sf::Vertex(sf::Vector2f(200, 0)),
    		sf::Vertex(sf::Vector2f(200, 400))
		};

		window -> draw(liney, 2, sf::Lines);

		sf::Vertex linex[] =
		{
    		sf::Vertex(sf::Vector2f(0, 200)),
    		sf::Vertex(sf::Vector2f(400, 200))
		};

		window -> draw(linex, 2, sf::Lines);
		
	}
	

	RenderWindow* window;
	thread m_thread;
};



#endif