#ifndef motor_controller_h
#define motor_controller_h

#include "../lib/ev3dev.h"

#include <iostream>
#include <vector>
#include <stdint.h>
#include <thread>
#include <math.h>  
#include "../include/sensor_controller.h"

#define SECTORS 4
#define TURN_SPEED 50

using namespace ev3dev;
using namespace std;

class Motor_Controller{

public:
	Motor_Controller(bool mocked): motor_left(OUTPUT_A),motor_right(OUTPUT_C) {
		//motor_left.set_speed_regulation_enabled('on');	
		//motor_right.set_speed_regulation_enabled('on');
		
		//
	}
	
	// Setzt die Zeit in ms und die Geschwindigkeit in % für den Motor, Aufruf erfolgt asnychron d.h. wird nicht manuell gewartet wird der 
	// restliche Code weiter durchlaufen ohne der Stelle zu "warten" 
	

	void robot_drive_forever(int speed){
		motor_right.set_duty_cycle_sp(speed);
		motor_left.set_duty_cycle_sp(speed);
		motor_left.run_forever();
		motor_right.run_forever();
	}	
	void robot_drive(int speed, int time){
		motor_right.set_duty_cycle_sp(speed);
		motor_right.set_time_sp(time).run_timed();
		motor_left.set_duty_cycle_sp(speed);
		motor_left.set_time_sp(time).run_timed();
	}

	void turn_left(int speed, int time){
		motor_right.set_duty_cycle_sp(speed);
		motor_right.set_time_sp(time).run_timed();
		motor_left.set_duty_cycle_sp(-speed);
		motor_left.set_time_sp(time).run_timed();
	}

	void turn_right(int speed, int time){
		motor_right.set_duty_cycle_sp(-speed);
		motor_right.set_time_sp(time).run_timed();
		motor_left.set_duty_cycle_sp(speed);
		motor_left.set_time_sp(time).run_timed();
	}

	void turn_left(int angle){
		int margin = 2;
		Sensor_Controller_Mock sensor(MOCKED);
		sensor.resetAngle();
		motor_right.set_duty_cycle_sp(TURN_SPEED);
		motor_left.set_duty_cycle_sp(-TURN_SPEED);
		motor_left.run_forever();
		motor_right.run_forever();
		
		motor_right.set_time_sp(10000).run_timed();
		//motor_left.set_duty_cycle_sp(speed);
		motor_left.set_time_sp(10000).run_timed();

		int position_reached = 0;
		while (position_reached != 2000){
			int measured = abs(sensor.measureAngle()) ;
			if(measured >= angle - margin && measured <= angle +margin){
				position_reached++;
			}
			if(measured >= angle + margin){
				turn_right(TURN_SPEED,10);
			}
			if(measured <= angle - margin){
				turn_left(TURN_SPEED,10);
			}
		}
		this -> robot_stop();
	}

	void turn_right(int angle){
		int margin = 2;
		Sensor_Controller_Mock sensor(MOCKED);
		sensor.resetAngle();
		motor_right.set_duty_cycle_sp(-TURN_SPEED);
		motor_left.set_duty_cycle_sp(TURN_SPEED);
		motor_left.run_forever();
		motor_right.run_forever();
		cout << " drehe rechts mit winkel " << angle << endl;
		int position_reached = 0;
		while (position_reached != 2000){
			int measured = abs(sensor.measureAngle()) ;
			if(measured >= angle - margin && measured <= angle +margin){
				position_reached++;
			}
			if(measured >= angle + margin){
				turn_left(TURN_SPEED,10);
			}
			if(measured <= angle - margin){
				turn_right(TURN_SPEED,10);
			}
		}
		this -> robot_stop();
	}

	void turn(int actual_direction, int direction){
		double angle = 0;
		int measures =  SNAPSHOT_MEASURES/SECTORS;
		int left_turn = 0;
		int right_turn = 0;
		if(actual_direction > direction){
			left_turn = abs(direction - actual_direction);
			right_turn = abs((direction + SNAPSHOT_MEASURES) - actual_direction);
		} else if(actual_direction < direction){
			left_turn = abs((actual_direction + SNAPSHOT_MEASURES) - direction); 
			right_turn = abs(direction - actual_direction);
		} else{
			return;
		}


		cout << " left " << left_turn << " " << " right " << right_turn << endl;
		if(left_turn < right_turn){
			//just for precision purpose
			if(left_turn >= measures){
				angle = 90;
			}
			angle = angle + (360/ SNAPSHOT_MEASURES) * (left_turn % measures);
			turn_left(angle);
		} else{
			if(right_turn >= measures){
				angle = 90;
				}
			angle = angle + (360/SNAPSHOT_MEASURES) * (right_turn % measures);
			turn_right(angle);
		}
		cout << "fertig turn" << endl;
	
	}

	// stoppt alle Motoren sofort. 
	void robot_stop(){
		motor_left.stop();
		motor_right.stop();
	}


	large_motor motor_left;
	large_motor motor_right;

};


// "mockt" das Verhalten indem einfach nichts gemacht wird wenn die Motoren angesteuert werden

class Motor_Controller_Mock : public Motor_Controller{

public:

	

	Motor_Controller_Mock(bool mocked): Motor_Controller(mocked){
		mock_motor = mocked;
	}

	void robot_drive(int speed, int time){
		if(!mock_motor){
			Motor_Controller::robot_drive(speed,time);
		} 
	}

	void turn_left(int speed, int time){
		if(!mock_motor){
			Motor_Controller::turn_left(speed,time);
		} 
	}

	void robot_stop(){
		if(!mock_motor){
			Motor_Controller::robot_stop();
		} 
	}

	void turn(int actual_direction, int direction){
		if(!mock_motor){
			Motor_Controller::turn(actual_direction,direction);
		}
	}

	void robot_drive_forever(int speed){
		if(!mock_motor){
			Motor_Controller::robot_drive_forever(speed);
		}
	}
private:

	bool mock_motor;
};


  


#endif