#include "../include/globals.h"
#include "../include/motor_controller.h"
#include "../include/sensor_controller.h"
#include "../include/map_manager.h"
#include <sys/mman.h>
#include "../include/map_buffer.h"
#include "../include/clock.h"
#include "../include/path_algorithm.h"
//#include "../include/map_viewer.h"


using namespace std;





void buffer_test(){
	Position* p1 = new Position(3,4);
	Position* p2 = new Position(41,12);

	Mem_Overhead* over = new Mem_Overhead(); 
	Mem_Infos* info = new Mem_Infos();
	info -> set_p1(*p1);
	info -> set_p2(*p2);
	info -> set_command(CONNECT_POINTS);
	over -> set_infos(*info);

	Map_Buffer_Writer* writer = new Map_Buffer_Writer();
	writer -> enqueue(info);
	writer -> enqueue(info);
	writer -> enqueue(info);

	Map_Buffer_Reader* reader = new Map_Buffer_Reader();
	reader -> dequeue();
	reader -> dequeue();
	Mem_Overhead i3 = reader -> dequeue();
	cout << "command " << (i3.get_infos()).get_command() << endl;
	cout << "p1.x " << ((i3.get_infos()).get_p1()).get_x() << endl;

	info -> set_command(DRAW_POINTS);
	writer -> enqueue(info);
	

	Mem_Overhead* iwas = (Mem_Overhead*)SHARED_MEM;
	cout << "Test " << (void*) iwas  << endl;
	cout << "Test " << (iwas -> get_state()) << endl;

	iwas = (Mem_Overhead*)SHARED_MEM +1 ;
	cout << "Test " << (void*) iwas  << endl;
	cout << "Test " << (iwas -> get_state()) << endl;

	cout << "size " << queue_size << endl;
	Mem_Overhead i4 = reader -> dequeue();
	cout << "command " << (i4.get_infos()).get_command() << endl;
	cout << "p1.x " << ((i4.get_infos()).get_p1()).get_x() << endl;
	cout << "State " << i4.get_state() << endl;

	Mem_Overhead i5 = reader -> dequeue();
	cout << "State " << i5.get_state() << endl;

	info -> set_command(CONNECT_POINTS);
	writer -> enqueue(info);

	Mem_Overhead i6 = reader -> dequeue();
	cout << "command " << (i6.get_infos()).get_command() << endl;
	cout << "p1.x " << ((i6.get_infos()).get_p1()).get_x() << endl;
	cout << "State " << i6.get_state() << endl;

	reader -> dequeue();
	reader -> dequeue();
	reader -> dequeue();
}


void file_test(){

	Map_Buffer_FileReader* reader = new Map_Buffer_FileReader();
	Infos_Time time = reader -> dequeue();
	cout << "hier " << time.get_time() << " " << ((time.get_infos()).get_p1()).get_x() << " " << ((time.get_infos()).get_p1()).get_y() <<
		" " << ((time.get_infos()).get_p2()).get_x() << " " << ((time.get_infos()).get_p2()).get_y() << endl;
	time = reader -> dequeue();
	cout << "hier " << time.get_time() << " " << ((time.get_infos()).get_p1()).get_x() << " " << ((time.get_infos()).get_p1()).get_y() <<
		" " << ((time.get_infos()).get_p2()).get_x() << " " << ((time.get_infos()).get_p2()).get_y() << endl;
		time = reader -> dequeue();
	cout << "hier " << time.get_time() << " " << ((time.get_infos()).get_p1()).get_x() << " " << ((time.get_infos()).get_p1()).get_y() <<
		" " << ((time.get_infos()).get_p2()).get_x() << " " << ((time.get_infos()).get_p2()).get_y() << endl;
		time = reader -> dequeue();
	cout << "hier " << time.get_time() << " " << ((time.get_infos()).get_p1()).get_x() << " " << ((time.get_infos()).get_p1()).get_y() <<
		" " << ((time.get_infos()).get_p2()).get_x() << " " << ((time.get_infos()).get_p2()).get_y() << endl;
		time = reader -> dequeue();
	cout << "hier " << time.get_time() << " " << ((time.get_infos()).get_p1()).get_x() << " " << ((time.get_infos()).get_p1()).get_y() <<
		" " << ((time.get_infos()).get_p2()).get_x() << " " << ((time.get_infos()).get_p2()).get_y() << endl;
}






int main(int argc, char** argv)
{

	
	



    //file_test();


	// the global mem for thread communication
	SHARED_MEM = mmap(0, SHARED_MEM_SIZE, PROT_READ | PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0);
	queue_size = 0;


	//	Motor_Controller controller = *new Motor_Controller();
	/**
	Motor_Controller controller = *new Motor_Controller();
	controller.robot_drive(50,2000);
	this_thread::sleep_for(chrono::milliseconds(3000));
	controller.turn_left(70,4000);
	this_thread::sleep_for(chrono::milliseconds(4000));
	controller.robot_drive(50,2000);
	this_thread::sleep_for(chrono::milliseconds(3000));
	*/


	Map_Manager map(SNAPSHOT_MEASURES);
	Motor_Controller_Mock motor(MOCKED);

	Path_Algorithm path(&map);
	Position pos;

	MyClock* clock = MyClock::get_Clock();
	clock -> start_Timer();
	
	while(true){

		// turn head and make Snapshot, evaluate it afterwards and draw points into map
		Snapshot* snap = map.make_Snapshot();
		map.evaluate_Snapshot(snap);
		map.draw_Snapshot_In_Map();

		// decide to which direction the roboter should turn
		int direction = path.decide_direction((map.getActualPosition()) -> get_x(), (map.getActualPosition()) -> get_y());
		motor.turn(map.getRobotDirection(),direction);
		map.setRobotDirection(direction);

		// continuously measure and drive until the roboter reached a barrier
		// actualize actual_position of the robot based on measurements 
		bool actualize = true;
		map.setLastMeasured(path.getMaxDistanceValue());
		while(actualize){
			actualize = map.actualize_position();
		}
	}
	return 0;

	
}




